EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_FOCUS_OBJECT_EVENT_FOCUS_CHANGED =
   EFL_EVENT_DESCRIPTION("focus,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_FOCUS_OBJECT_EVENT_FOCUS_MANAGER_CHANGED =
   EFL_EVENT_DESCRIPTION("focus_manager,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_FOCUS_OBJECT_EVENT_FOCUS_PARENT_CHANGED =
   EFL_EVENT_DESCRIPTION("focus_parent,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_FOCUS_OBJECT_EVENT_CHILD_FOCUS_CHANGED =
   EFL_EVENT_DESCRIPTION("child_focus,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_FOCUS_OBJECT_EVENT_FOCUS_GEOMETRY_CHANGED =
   EFL_EVENT_DESCRIPTION("focus_geometry,changed");

static Eina_Rect __eolian_efl_ui_focus_object_focus_geometry_get(const Eo *obj EINA_UNUSED, Efl_Ui_Focus_Object_Data *pd EINA_UNUSED)
{
   return (EINA_RECT_EMPTY());
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_focus_object_focus_geometry_get, Eina_Rect, (EINA_RECT_EMPTY()));

void _efl_ui_focus_object_focus_set(Eo *obj, Efl_Ui_Focus_Object_Data *pd, Eina_Bool focus);


static Eina_Error
__eolian_efl_ui_focus_object_focus_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_focus_object_focus_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_focus_object_focus_set, EFL_FUNC_CALL(focus), Eina_Bool focus);

Eina_Bool _efl_ui_focus_object_focus_get(const Eo *obj, Efl_Ui_Focus_Object_Data *pd);


static Eina_Value
__eolian_efl_ui_focus_object_focus_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_focus_object_focus_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_focus_object_focus_get, Eina_Bool, 0);

static Efl_Ui_Focus_Manager *__eolian_efl_ui_focus_object_focus_manager_get(const Eo *obj EINA_UNUSED, Efl_Ui_Focus_Object_Data *pd EINA_UNUSED)
{
   return NULL;
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_focus_object_focus_manager_get, Efl_Ui_Focus_Manager *, NULL);

static Efl_Ui_Focus_Object *__eolian_efl_ui_focus_object_focus_parent_get(const Eo *obj EINA_UNUSED, Efl_Ui_Focus_Object_Data *pd EINA_UNUSED)
{
   return NULL;
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_focus_object_focus_parent_get, Efl_Ui_Focus_Object *, NULL);

void _efl_ui_focus_object_child_focus_set(Eo *obj, Efl_Ui_Focus_Object_Data *pd, Eina_Bool child_focus);


static Eina_Error
__eolian_efl_ui_focus_object_child_focus_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_focus_object_child_focus_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_focus_object_child_focus_set, EFL_FUNC_CALL(child_focus), Eina_Bool child_focus);

Eina_Bool _efl_ui_focus_object_child_focus_get(const Eo *obj, Efl_Ui_Focus_Object_Data *pd);


static Eina_Value
__eolian_efl_ui_focus_object_child_focus_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_focus_object_child_focus_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_focus_object_child_focus_get, Eina_Bool, 0);

void _efl_ui_focus_object_setup_order(Eo *obj, Efl_Ui_Focus_Object_Data *pd);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODY(efl_ui_focus_object_setup_order);

static void __eolian_efl_ui_focus_object_setup_order_non_recursive(Eo *obj EINA_UNUSED, Efl_Ui_Focus_Object_Data *pd EINA_UNUSED)
{
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODY(efl_ui_focus_object_setup_order_non_recursive);

static Eina_Bool __eolian_efl_ui_focus_object_on_focus_update(Eo *obj EINA_UNUSED, Efl_Ui_Focus_Object_Data *pd EINA_UNUSED)
{
   return 0;
}

EAPI EAPI_WEAK EFL_FUNC_BODY(efl_ui_focus_object_on_focus_update, Eina_Bool, 0);

static Eina_Bool
_efl_ui_focus_object_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_FOCUS_OBJECT_EXTRA_OPS
#define EFL_UI_FOCUS_OBJECT_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_focus_object_focus_geometry_get, __eolian_efl_ui_focus_object_focus_geometry_get),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_object_focus_set, _efl_ui_focus_object_focus_set),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_object_focus_get, _efl_ui_focus_object_focus_get),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_object_focus_manager_get, __eolian_efl_ui_focus_object_focus_manager_get),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_object_focus_parent_get, __eolian_efl_ui_focus_object_focus_parent_get),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_object_child_focus_set, _efl_ui_focus_object_child_focus_set),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_object_child_focus_get, _efl_ui_focus_object_child_focus_get),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_object_setup_order, _efl_ui_focus_object_setup_order),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_object_setup_order_non_recursive, __eolian_efl_ui_focus_object_setup_order_non_recursive),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_object_on_focus_update, __eolian_efl_ui_focus_object_on_focus_update),
      EFL_UI_FOCUS_OBJECT_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"focus", __eolian_efl_ui_focus_object_focus_set_reflect, __eolian_efl_ui_focus_object_focus_get_reflect},
      {"child_focus", __eolian_efl_ui_focus_object_child_focus_set_reflect, __eolian_efl_ui_focus_object_child_focus_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_focus_object_class_desc = {
   EO_VERSION,
   "Efl.Ui.Focus.Object",
   EFL_CLASS_TYPE_MIXIN,
   sizeof(Efl_Ui_Focus_Object_Data),
   _efl_ui_focus_object_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_focus_object_mixin_get, &_efl_ui_focus_object_class_desc, NULL, NULL);
